import copy
import time

class Attack :
  def __init__(self,name,power,proba,range,online, bp = 0):
    self.name   = name
    self.power  = power
    self.online = online
    self.proba  = proba
    self.range  = range
    self.bandwidth  = bp

class Evolution :
  def __init__(self,name) :
    self.name = name

class Player:
  """ player class """

  def __init__(self, flop, bp, money, spamming, infecting, evolving, structures, nextVersion):
    """ simple constructor for the player class """
    self.flop           = flop
    self.bandwidth      = bp
    self.availablebp    = bp
    self.money          = money
    self.infecting      = infecting
    self.evolving       = evolving
    self.structures     = structures
    self.attacks        = [Attack("ddos",100,0.5,25,True, 5), Attack("wifi",50,0.5,0,False, 1)]
    self.time           = time.time()
    self.selectedAttack = None
    self.loose          = False
    self.win            = False
    
    
  def getFlop(self):
    """ flop getter """
    return self.flop

  def setFlop(self, flop):
    """ flop setter  """
    self.flop = flop
    return flop

  def getBandwidth(self):
    """ flop getter """
    return self.bandwidth

  def setBandwidth(self, bandwidth):
    """ flop setter  """
    self.bandwidth = bandwidth
    return self.bandwidth

  def getMoney(self):
    """ money getter """
    return self.money

  def setMoney(self, money):
    """ money setter  """
    self.money = money
    return self.money

  def getSpamming(self):
    """ spamming getter """
    return self.spamming

  def setSpamming(self, spamming):
    """ spamming setter  """
    self.spamming = spamming
    return self.spamming

  def getInfecting(self):
    """ infecting getter """
    return self.infecting

  def setInfecting(self, infecting):
    """ infecting setter  """
    self.infecting = infecting
    return infecting

  def getEvolving(self):
    """ evolving getter """
    return self.evolving

  def setEvolving(self, evolving):
    """ evolving setter  """
    self.evolving = evolving
    return self.evolving

  def getStructures(self):
    """ structures getter """
    struct = copy.deepcopy(self.structures)
    return struct

  def setStructures(self, structures):
    """ structures setter  """
    self.structures = copy.deepcopy(structures)
    struct = copy.deepcopy(self.structures)
    return struct
    
  def getProba(self):
    return self.infecting/100.*self.bandwidth

  def addInfecting(self,val):
    sum = self.infecting
    if  (sum + val) <= 100 and 0 <= (self.infecting + val):
      self.infecting += val
  
  def getEvolutions(self) :
    return self.evolutions
    
  def setEvolution(self,value) :
    self.evolution = self.evolutions[value]
    return self.evolution

  def getAttacks(self) :
    return self.attacks
  
  def selectAttack(self,value) :
    self.selectedAttack = self.attacks[value]
  
  def noAttack(self) :
    self.selectedAttack = False
