import pygame
from pygame import Rect
from data import filepath

class Control(Rect) :
  
  catalog = []
  
  def __init__(self,rect):
    Rect.__init__(self,rect.left,rect.top,rect.width,rect.height)
    self.__class__.catalog.append(self)
    
  def action(self) :
    pass
    
  def click(self,pos,button,value = 0) :
    if self.collidepoint(pos) :
      if button == 3 :
        value = -value
      self.action(value)
    else : return

class ListControl(Control):
  def __init__(self,rect,player,choice,value) :
    Control.__init__(self,rect)  
    self.player = player
    self.choice = choice
    self.value = value
    
  def action(self,wtf):
    if self.choice == "attacks" :
      self.player.selectAttack(self.value)
    if self.choice == "evolutions" :
      self.player.setEvolution(self.value)

    
class BottomRightControl(Control) :
  def __init__(self,rect,player,cible):
    Control.__init__(self,rect)
    self.action = player.addInfecting
